import * as React from 'react';
import Menu from '@material/react-menu';
import { OptionProps } from './Option';
import { CommonSelectProps } from './BaseSelect';
export declare type EnhancedChild<T extends HTMLElement> = React.ReactElement<OptionProps<T>>;
export interface EnhancedSelectProps extends CommonSelectProps, React.HTMLProps<HTMLElement> {
    closeMenu?: () => void;
    onEnhancedChange?: (index: number, item: Element) => void;
    anchorElement: HTMLElement | null;
    value?: string;
    ref?: React.Ref<any>;
    isInvalid?: boolean;
}
interface EnhancedSelectState {
    'aria-expanded'?: boolean | 'false' | 'true';
    selectedItem: Element | null;
    selectedValue?: string;
}
export default class EnhancedSelect extends React.Component<EnhancedSelectProps, EnhancedSelectState> {
    nativeControl: React.RefObject<HTMLSelectElement>;
    private selectedTextEl;
    menuEl: React.RefObject<Menu>;
    static defaultProps: Partial<EnhancedSelectProps>;
    state: EnhancedSelectState;
    componentDidUpdate(prevProps: EnhancedSelectProps): void;
    readonly listElements: false | Element[];
    setSelected: () => void;
    private getIndexByValue;
    private handleMenuClose;
    private handleMenuOpen;
    render(): JSX.Element;
}
export {};
